=== modified file 'src/com/goldencode/p2j/main/ClientBuilderOptions.java'
--- src/com/goldencode/p2j/main/ClientBuilderOptions.java	2023-05-12 10:05:12 +0000
+++ src/com/goldencode/p2j/main/ClientBuilderOptions.java	2023-12-08 06:53:47 +0000
@@ -27,6 +27,7 @@
 **         20210926 Moved "getAvailablePorts" logic to WebClientsManager.
 ** 012 SBI 20230411 Added getOverriddenOptions(), overrideClientOption, overrideWebClientPortOption.
 ** 013 GBB 20230512 Logging methods replaced by CentralLogger/ConversionStatus.
+** 014 SBI 20231208 Applied the debug profile if the web client starts the java debug agent.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -308,6 +309,7 @@
       if (debuggerPort > 0)
       {
          updateJvmArgument("-Xrunjdwp:transport", String.format(DEBUGGER_TRANSPORT, debuggerPort));
+         applyDebugProfile();
       }
    }
 
@@ -326,6 +328,42 @@
    }
 
    /**
+    * Apply debug profile to simplify web client debugging, using breakpoints while
+    * web client forced to be inactive.
+    */
+   public void applyDebugProfile()
+   {
+      overrideClientOption("webSocketTimeout", String.valueOf(WebClientDebugConfig.MAX_IDLE_TIME), true);
+      overrideClientOption("watchdogTimeout", String.valueOf(WebClientDebugConfig.WATCH_DOG_TIMEOUT), true);
+      overrideClientOption("maxIdleTime", String.valueOf(WebClientDebugConfig.MAX_IDLE_TIME), true);
+      overrideClientOption("maxHttpIdleTimeout", String.valueOf(WebClientDebugConfig.INFINITE_TIMEOUT), true);
+      overrideClientOption("delayBetweenTriesToConnect", String.valueOf(WebClientDebugConfig.DELAY_BETWEEN_CONNECT_TRIES), true);
+      overrideClientOption("pingPongInterval", String.valueOf(WebClientDebugConfig.PING_PONG_INTERVAL), true);
+      overrideClientOption("maxLostPings", String.valueOf(WebClientDebugConfig.MAX_LOST_PINGS), true);
+      overrideClientOption("delayBetweenPingTries", String.valueOf(WebClientDebugConfig.DELAY_BETWEEN_PING_TRIES), true);
+      overrideClientOption("enableDebugLogging", String.valueOf(WebClientDebugConfig.ENABLE_DEBUG_LOGGING), true);
+   }
+   
+   /**
+    * Add the given named option to the overridden options map.
+    * 
+    * @param    name
+    *           The option name
+    * @param    value
+    *           The option value
+    * @param    debug
+    *           The boolean value that indicates that the option needs to be logged. 
+    */
+   public void overrideClientOption(String name, String value, boolean debug)
+   {
+      overriddenOptions.put(name, value);
+      if (debug)
+      {
+         warn(name, value);
+      }
+   }
+
+   /**
     * Add the given named option to the overridden options map.
     * 
     * @param    name
@@ -335,7 +373,7 @@
     */
    public void overrideClientOption(String name, String value)
    {
-      overriddenOptions.put(name, value);
+      overrideClientOption(name, value, false);
    }
 
    /**
@@ -433,6 +471,19 @@
    }
 
    /**
+    * Logs a warning that the parameter is overridden with new value
+    * 
+    * @param    parameter
+    *           The parameter name
+    * @param    value
+    *           The parameter value
+    */
+   private static void warn(String parameter, String value)
+   {
+      LOG.warning("DEBUG MODE: " + parameter + " = " + value);
+   }
+
+   /**
     * Get default path as the p2j.jar file location.
     * 
     * @return  Path to p2j.jar file.

=== modified file 'src/com/goldencode/p2j/main/WebClientBuilderOptions.java'
--- src/com/goldencode/p2j/main/WebClientBuilderOptions.java	2023-11-21 12:56:19 +0000
+++ src/com/goldencode/p2j/main/WebClientBuilderOptions.java	2023-12-08 06:58:17 +0000
@@ -32,6 +32,7 @@
 ** 009 SBI 20230411 Added lang option and changed getClientOptions to use getOverriddenOptions()
 ** 010 GBB 20230825 Cleanup for embedded.
 ** 011 GBB 20231121 Added broadcastChannelPingTimeout.
+** 012 SBI 20231208 Used the common constants.
  */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -258,41 +259,59 @@
    
       // common websocket parameters
       int maxBinaryMessage = cbo.getNode(DIRECTORY_NODE_ID,
-                                         "maxBinaryMessage",
+                                         MAX_BINARY_MESSAGE_SIZE_PARAM,
                                          MAX_BINARY_MESSAGE_SIZE);
       int maxTextMessage   = cbo.getNode(DIRECTORY_NODE_ID,
-                                         "maxTextMessage",
+                                         MAX_TEXT_MESSAGE_SIZE_PARAM,
                                          MAX_TEXT_MESSAGE_SIZE);
-      int maxIdleTime      = cbo.getNode(DIRECTORY_NODE_ID, "maxIdleTime", MAX_WEB_SOCKET_IDLE_TIMEOUT);
+      int maxIdleTime      = cbo.getNode(DIRECTORY_NODE_ID,
+                                         MAX_IDLE_TIME_PARAM,
+                                         MAX_WEB_SOCKET_IDLE_TIMEOUT);
       
       int delayBetweenTriesToConnect = cbo.getNode(DIRECTORY_NODE_ID,
-                                                   "delayBetweenTriesToConnect",
+                                                   DELAY_BETWEEN_CONNECT_TRIES_PARAM,
                                                    DELAY_BETWEEN_CONNECT_TRIES);
       String tryToConnectMessage =  quotedString(cbo.getNode(DIRECTORY_NODE_ID,
-                                                             "tryToConnectMessage",
+                                                             TRY_TO_CONNECT_MESSAGE_PARAM,
                                                              TRY_TO_CONNECT_MESSAGE));
       String serverUnavailableMessage = quotedString(cbo.getNode(DIRECTORY_NODE_ID,
-                                                                 "serverUnavailableMessage",
+                                                                 SERVER_UNAVAILABLE_MESSAGE_PARAM,
                                                                  SERVER_UNAVAILABLE_MESSAGE));
       String connectionRestoredMessage = quotedString(cbo.getNode(DIRECTORY_NODE_ID,
-                                                                  "connectionRestoredMessage",
+                                                                  CONNECTION_RESTORED_MESSAGE_PARAM,
                                                                   CONNECTION_RESTORED_MESSAGE));
-      int pingPongInterval = cbo.getNode(DIRECTORY_NODE_ID, "pingPongInterval", PING_PONG_INTERVAL);
-      
-      int maxLostPings = cbo.getNode(DIRECTORY_NODE_ID, "maxLostPings", MAX_LOST_PINGS);
-      
-      int delayBetweenPingTries = cbo.getNode(DIRECTORY_NODE_ID, "delayBetweenPingTries", DELAY_BETWEEN_PING_TRIES);
+      int pingPongInterval = cbo.getNode(DIRECTORY_NODE_ID,
+                                         PING_PONG_INTERVAL_PARAM,
+                                         PING_PONG_INTERVAL);
+      
+      int maxLostPings = cbo.getNode(DIRECTORY_NODE_ID,
+                                     MAX_LOST_PINGS_PARAM,
+                                     MAX_LOST_PINGS);
+      
+      int delayBetweenPingTries = cbo.getNode(DIRECTORY_NODE_ID,
+                                              DELAY_BETWEEN_PING_TRIES_PARAM,
+                                              DELAY_BETWEEN_PING_TRIES);
       
       //http configuration settings for the embedded web server
-      int maxOutputBufferSize = cbo.getNode(DIRECTORY_NODE_ID, "maxOutputBufferSize", OUTPUT_BUFFER_SIZE);
+      int maxOutputBufferSize = cbo.getNode(DIRECTORY_NODE_ID,
+                                            MAX_OUTPUT_BUFFER_SIZE_PARAM,
+                                            OUTPUT_BUFFER_SIZE);
       options.put("maxOutputBufferSize", String.valueOf(maxOutputBufferSize));
-      int maxOutputAggregationSize = cbo.getNode(DIRECTORY_NODE_ID, "maxOutputAggregationSize", OUTPUT_AGGREGATION_SIZE);
+      int maxOutputAggregationSize = cbo.getNode(DIRECTORY_NODE_ID,
+                                                 MAX_OUTPUT_AGGREGATION_SIZE_PARAM,
+                                                 OUTPUT_AGGREGATION_SIZE);
       options.put("maxOutputAggregationSize", String.valueOf(maxOutputAggregationSize));
-      int maxHttpIdleTimeout =  cbo.getNode(DIRECTORY_NODE_ID, "maxHttpIdleTimeout", MAX_HTTP_IDLE_TIMEOUT);
+      int maxHttpIdleTimeout =  cbo.getNode(DIRECTORY_NODE_ID,
+                                            EMB_WEB_SERVER_MAX_IDLE_TIMEOUT_PARAM,
+                                            INFINITE_TIMEOUT);
       options.put("maxHttpIdleTimeout", String.valueOf(maxHttpIdleTimeout));
-      int maxResponseHeaderSize = cbo.getNode(DIRECTORY_NODE_ID, "maxResponseHeaderSize", RESPONSE_HEADER_SIZE);
+      int maxResponseHeaderSize = cbo.getNode(DIRECTORY_NODE_ID,
+                                              MAX_RESPONSE_HEADER_SIZE_PARAM,
+                                              RESPONSE_HEADER_SIZE);
       options.put("maxResponseHeaderSize", String.valueOf(maxResponseHeaderSize));
-      int maxRequestHeaderSize = cbo.getNode(DIRECTORY_NODE_ID, "maxRequestHeaderSize", REQUEST_HEADER_SIZE);
+      int maxRequestHeaderSize = cbo.getNode(DIRECTORY_NODE_ID,
+                                             MAX_REQUEST_HEADER_SIZE_PARAM,
+                                             REQUEST_HEADER_SIZE);
       options.put("maxRequestHeaderSize", String.valueOf(maxRequestHeaderSize));
 
       // the possible values for renderer are webgl and 2d (case insensitive)

=== modified file 'src/com/goldencode/p2j/main/WebClientConstants.java'
--- src/com/goldencode/p2j/main/WebClientConstants.java	2022-11-21 20:39:05 +0000
+++ src/com/goldencode/p2j/main/WebClientConstants.java	2023-09-27 00:02:22 +0000
@@ -2,7 +2,7 @@
 ** Module   : WebClientConstants.java
 ** Abstract : Defines the web client constants.
 **
-** Copyright (c) 2021-2022, Golden Code Development Corporation.
+** Copyright (c) 2021-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ------------------------------Description----------------------------------
 ** 001 SBI 20210512 Added common constants used by web client.
@@ -11,6 +11,7 @@
 **         20210914 Added default values for enableDebugLogging.
 **         20211003 Renamed MAX_IDLE_TIMEOUT to MAX_WEB_SOCKET_IDLE_TIMEOUT.
 ** 002     20221121 Fixed spelling errors.
+** 003 SBI 20230926 Added new constants that represent parameter names.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -117,5 +118,49 @@
    
    /** This default message is shown if the web socket connection has been restored. */
    String CONNECTION_RESTORED_MESSAGE = "The server connection has been restored.";
-
+   
+   /**
+    * The "maxBinaryMessage" parameter name
+    */
+   String MAX_BINARY_MESSAGE_SIZE_PARAM = "maxBinaryMessage";
+   
+   /**
+    * The "maxTextMessage" parameter name
+    */
+   String MAX_TEXT_MESSAGE_SIZE_PARAM = "maxTextMessage";
+   
+   /**
+    * The "delayBetweenTriesToConnect" parameter name
+    */
+   String DELAY_BETWEEN_PING_TRIES_PARAM = "delayBetweenTriesToConnect";
+   
+   /**
+    * The "pingPongInterval" parameter name
+    */
+   String PING_PONG_INTERVAL_PARAM = "pingPongInterval";
+   
+   /**
+    * The "maxLostPings" parameter name
+    */
+   String MAX_LOST_PINGS_PARAM = "maxLostPings";
+   
+   /**
+    * The "delayBetweenTriesToConnect" parameter name
+    */
+   String DELAY_BETWEEN_CONNECT_TRIES_PARAM = "delayBetweenTriesToConnect";
+   
+   /**
+    * The "tryToConnectMessage" parameter name
+    */
+   String TRY_TO_CONNECT_MESSAGE_PARAM = "tryToConnectMessage";
+   
+   /**
+    * The "serverUnavailableMessage" parameter name
+    */
+   String SERVER_UNAVAILABLE_MESSAGE_PARAM = "serverUnavailableMessage";
+   
+   /**
+    * The "connectionRestoredMessage" parameter name
+    */
+   String CONNECTION_RESTORED_MESSAGE_PARAM = "connectionRestoredMessage";
 }

=== added file 'src/com/goldencode/p2j/main/WebClientDebugConfig.java'
--- src/com/goldencode/p2j/main/WebClientDebugConfig.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/main/WebClientDebugConfig.java	2023-09-27 00:02:22 +0000
@@ -0,0 +1,87 @@
+/*
+** Module   : WebClientDebugConfig.java
+** Abstract : Defines common configuration settings required for debugging web clients.
+**
+** Copyright (c) 2023, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------------Description--------------------------
+** 001 SBI 20230925 Added web client debug configuration settings.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+
+package com.goldencode.p2j.main;
+
+import com.goldencode.p2j.web.HttpConfigurationConstants;
+
+/**
+ * Defines the debug configuration settings that should override the directory and the default configuration settings
+ * if the java debug agent is set.
+ */
+public interface WebClientDebugConfig
+extends WebClientConstants,
+        HttpConfigurationConstants
+{
+   /** Override the default idle time after which the connection should be closed */
+   int MAX_IDLE_TIME = 20 * 60 * 1000;
+   
+   /** Override the default watch dog timeout */
+   int WATCH_DOG_TIMEOUT = 40 * 60 * 1000;
+   
+   /** Override the default delay between successful MSG_PING_PONG pairs if the server replies with MSG_PING_PONG */
+   int PING_PONG_INTERVAL = 20 * 60 * 1000;
+   
+   /** Override the default debug logging for the web client */
+   boolean ENABLE_DEBUG_LOGGING = true;
+}

=== modified file 'src/com/goldencode/p2j/main/WebServer.java'
--- src/com/goldencode/p2j/main/WebServer.java	2023-05-12 10:05:12 +0000
+++ src/com/goldencode/p2j/main/WebServer.java	2023-12-08 06:58:22 +0000
@@ -51,6 +51,8 @@
 **         20210812          Added createContextHandler() method to encapsulate and reuse this logic.
 **         20211003          Moved common constants to HttpConfigurationConstants.
 ** 022 GBB 20230512          Logging methods replaced by CentralLogger/ConversionStatus.
+** 023 SBI 20231208          Fixed the default idle timeout for web server http configuration and replaced coded
+**                           parameters with corresponding defined constants.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -158,24 +160,37 @@
       // server-scoped directory search for the admin port number
       port = Utils.getDirectoryNodeInt(null, "adminPort", HTTPS_PORT, false);
       
-      int maxOutputBufferSize = Utils.getDirectoryNodeInt(null, "maxOutputBufferSize", OUTPUT_BUFFER_SIZE, false);
+      int maxOutputBufferSize = Utils.getDirectoryNodeInt(null,
+                                                          MAX_OUTPUT_BUFFER_SIZE_PARAM,
+                                                          OUTPUT_BUFFER_SIZE,
+                                                          false);
       getHttpConfiguration().setOutputBufferSize(maxOutputBufferSize);
-      int maxOutputAggregationSize = Utils.getDirectoryNodeInt(null, "maxOutputAggregationSize", OUTPUT_AGGREGATION_SIZE, false);
+      int maxOutputAggregationSize = Utils.getDirectoryNodeInt(null,
+                                                               MAX_OUTPUT_AGGREGATION_SIZE_PARAM,
+                                                               OUTPUT_AGGREGATION_SIZE,
+                                                               false);
       if (maxOutputAggregationSize != OUTPUT_AGGREGATION_SIZE)
       {
          getHttpConfiguration().setOutputAggregationSize(maxOutputAggregationSize);
       }
-      int maxIdleTimeout = Utils.getDirectoryNodeInt(null, "maxIdleTimeout", -1, false);
-      if (maxIdleTimeout >= 0)
-      {
-         getHttpConfiguration().setIdleTimeout(maxIdleTimeout);
-      }
-      int maxResponseHeaderSize = Utils.getDirectoryNodeInt(null, "maxResponseHeaderSize", RESPONSE_HEADER_SIZE, false);
+      int maxIdleTimeout = Utils.getDirectoryNodeInt(null,
+                                                     WEB_SERVER_MAX_IDLE_TIMEOUT_PARAM,
+                                                     CONNECTION_TIMEOUT,
+                                                     false);
+      getHttpConfiguration().setIdleTimeout(maxIdleTimeout);
+      
+      int maxResponseHeaderSize = Utils.getDirectoryNodeInt(null,
+                                                            MAX_RESPONSE_HEADER_SIZE_PARAM,
+                                                            RESPONSE_HEADER_SIZE,
+                                                            false);
       if (maxResponseHeaderSize != RESPONSE_HEADER_SIZE)
       {
          getHttpConfiguration().setResponseHeaderSize(maxResponseHeaderSize);
       }
-      int maxRequestHeaderSize = Utils.getDirectoryNodeInt(null, "maxRequestHeaderSize", REQUEST_HEADER_SIZE, false);
+      int maxRequestHeaderSize = Utils.getDirectoryNodeInt(null,
+                                                           MAX_REQUEST_HEADER_SIZE_PARAM,
+                                                           REQUEST_HEADER_SIZE,
+                                                           false);
       if (maxRequestHeaderSize != REQUEST_HEADER_SIZE)
       {
          getHttpConfiguration().setRequestHeaderSize(maxRequestHeaderSize);

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java	2023-11-30 14:09:21 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/GuiWebDriver.java	2023-12-08 06:55:59 +0000
@@ -235,6 +235,7 @@
 ** 076 GBB 20231113 Adding storageId param to getLocalStorageAccessor. Implementing new interface ScreenWebDriver.
 **                  Adding getBrowserWebSocket(). Reading config broadcastChannelPingTimeout.
 ** 077 GBB 20231130 ScreenDriver getName() implemented.
+** 078 SBI 20231208 Replaced coded config parameters with corresponding defined constants.
 */
 
 /*
@@ -658,15 +659,30 @@
                                          new GenericWebSocketCreator<WebClientProtocol>(websock),
                                          cpres,
                                          hdlrs);
-      int maxOutputBufferSize = config.getInt("client", "web", "maxOutputBufferSize", OUTPUT_BUFFER_SIZE);
+      int maxOutputBufferSize = config.getInt("client",
+                                              "web",
+                                              MAX_OUTPUT_BUFFER_SIZE_PARAM,
+                                              OUTPUT_BUFFER_SIZE);
       websrv.getHttpConfiguration().setOutputBufferSize(maxOutputBufferSize);
-      int maxOutputAggregationSize = config.getInt("client", "web", "maxOutputAggregationSize", OUTPUT_AGGREGATION_SIZE);
+      int maxOutputAggregationSize = config.getInt("client",
+                                                   "web",
+                                                   MAX_OUTPUT_AGGREGATION_SIZE_PARAM,
+                                                   OUTPUT_AGGREGATION_SIZE);
       websrv.getHttpConfiguration().setOutputAggregationSize(maxOutputAggregationSize);
-      int maxHttpIdleTimeout = config.getInt("client", "web", "maxHttpIdleTimeout", MAX_HTTP_IDLE_TIMEOUT);
+      int maxHttpIdleTimeout = config.getInt("client",
+                                             "web",
+                                             MAX_HTTP_IDLE_TIMEOUT_PARAM,
+                                             INFINITE_TIMEOUT);
       websrv.getHttpConfiguration().setIdleTimeout(maxHttpIdleTimeout);
-      int maxResponseHeaderSize = config.getInt("client", "web", "maxResponseHeaderSize", RESPONSE_HEADER_SIZE);
+      int maxResponseHeaderSize = config.getInt("client",
+                                                "web",
+                                                MAX_RESPONSE_HEADER_SIZE_PARAM,
+                                                RESPONSE_HEADER_SIZE);
       websrv.getHttpConfiguration().setResponseHeaderSize(maxResponseHeaderSize);
-      int maxRequestHeaderSize = config.getInt("client", "web", "maxRequestHeaderSize", REQUEST_HEADER_SIZE);
+      int maxRequestHeaderSize = config.getInt("client",
+                                               "web",
+                                               MAX_REQUEST_HEADER_SIZE_PARAM,
+                                               REQUEST_HEADER_SIZE);
       websrv.getHttpConfiguration().setRequestHeaderSize(maxRequestHeaderSize);
    }
 

=== modified file 'src/com/goldencode/p2j/web/HttpConfigurationConstants.java'
--- src/com/goldencode/p2j/web/HttpConfigurationConstants.java	2021-10-04 09:27:52 +0000
+++ src/com/goldencode/p2j/web/HttpConfigurationConstants.java	2023-12-08 06:59:43 +0000
@@ -2,10 +2,11 @@
 ** Module   : HttpConfigurationConstants.java
 ** Abstract : Defines common http configuration settings.
 **
-** Copyright (c) 2021, Golden Code Development Corporation.
+** Copyright (c) 2021-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ----------------------Description--------------------------
 ** 001 SBI 20211003 Added common http configuration settings.
+** 002 SBI 20231208 Added http configuration parameters.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -78,9 +79,54 @@
    int REQUEST_HEADER_SIZE = 8 * 1024;
    
    /**
-    * The maximal http idle timeout, infinite timeout. -1 means that the connection timeout is used,
-    * 0 implies infinite timeout, max idle time is applied to an HTTP request for IO operations
-    * and delayed dispatch.
-    */
-   int MAX_HTTP_IDLE_TIMEOUT = 0;
+    * The connection timeout for setting max idle time, max idle time is applied to an HTTP request for IO operations
+    * and delayed dispatch.
+    */
+   int CONNECTION_TIMEOUT = -1;
+   
+   /**
+    * The infinite timeout for setting max idle time, max idle time is applied to an HTTP request for IO operations
+    * and delayed dispatch.
+    */
+   int INFINITE_TIMEOUT = 0;
+   
+   /**
+    * The "maxHttpIdleTimeout" parameter name
+    */
+   String MAX_HTTP_IDLE_TIMEOUT_PARAM = "maxHttpIdleTimeout";
+   
+   /**
+    * The "maxOutputBufferSize" parameter name
+    */
+   String MAX_OUTPUT_BUFFER_SIZE_PARAM = "maxOutputBufferSize";
+   
+   /**
+    * The "maxOutputAggregationSize" parameter name
+    */
+   String MAX_OUTPUT_AGGREGATION_SIZE_PARAM = "maxOutputAggregationSize";
+   
+   /**
+    * The "webServerMaxIdleTimeout" parameter name
+    */
+   String WEB_SERVER_MAX_IDLE_TIMEOUT_PARAM = "webServerMaxIdleTimeout";
+   
+   /**
+    * The "embWebServerMaxIdleTimeout" parameter name
+    */
+   String EMB_WEB_SERVER_MAX_IDLE_TIMEOUT_PARAM = "embWebServerMaxIdleTimeout";
+   
+   /**
+    * The "maxIdleTime" parameter name
+    */
+   String MAX_IDLE_TIME_PARAM = "maxIdleTime";
+   
+   /**
+    * The "maxResponseHeaderSize" parameter name
+    */
+   String MAX_RESPONSE_HEADER_SIZE_PARAM = "maxResponseHeaderSize";
+   
+   /**
+    * The "maxRequestHeaderSize" parameter name
+    */
+   String MAX_REQUEST_HEADER_SIZE_PARAM = "maxRequestHeaderSize";
 }