=== modified file 'src/com/goldencode/p2j/ui/EditorWidget.java'
--- old/src/com/goldencode/p2j/ui/EditorWidget.java	2023-09-27 07:59:13 +0000
+++ new/src/com/goldencode/p2j/ui/EditorWidget.java	2024-02-01 14:33:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : EditorWidget.java
 ** Abstract : server side Editor widget implementation
 **
-** Copyright (c) 2006-2022, Golden Code Development Corporation.
+** Copyright (c) 2006-2024, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --JPRM-- ---------------------------Description----------------------------
 ** 001 SIY 20060427   @26084 Server side part of the EDITOR widget.
@@ -74,6 +74,7 @@
 **     EVL 20221122          Adding suppot for LARGE attribute to be serialized on the client side.
 ** 042 SAT 20230927          Changed the calls of LogicalTerminal.setEditorCursorOffset() to 
 **                           LogicalTerminal.setCursorOffset().
+** 043 RAA 20240201          Added unparsedValue parameter to setScreenValue. 
 */
 
 /*
@@ -2052,11 +2053,14 @@
     *          The value to be set via SCREEN-VALUE attribute.
     * @param   inUIStmt
     *          Flag indicating this call originates from a UI statement.
+    * @param   unparsedValue
+    *          The value to be set via SCREEN-VALUE before suffering parse changes. This can be omitted
+    *          if it is not mandatory during validation.
     *          
     * @return  <code>true</code> if the caller can proceed, as the screen-value can be set.
     */
    @Override
-   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt)
+   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt, character unparsedValue)
    {
       if (value instanceof BaseDataType && ((BaseDataType) value).isUnknown())
       {

=== modified file 'src/com/goldencode/p2j/ui/SelectionListWidget.java'
--- old/src/com/goldencode/p2j/ui/SelectionListWidget.java	2023-11-15 08:24:44 +0000
+++ new/src/com/goldencode/p2j/ui/SelectionListWidget.java	2024-02-01 14:35:21 +0000
@@ -2,7 +2,7 @@
 ** Module   : SelectionListWidget.java
 ** Abstract : server side selection list widget implementation
 **
-** Copyright (c) 2005-2022, Golden Code Development Corporation.
+** Copyright (c) 2005-2024, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --JPRM-- -----------------------------Description----------------------------
 ** 001 NVS 20051026   @23495 Created initial version.
@@ -64,6 +64,7 @@
 **     VVT 20220405          Regression fixed: zero selection list widget height, introduced in
 **                           rev. 13675. See #5937-79.
 ** 027 RAA 20231115          Added unparsedValue parameter to validateScreenValue function.
+** 028 RAA 20240201          Added unparsedValue parameter to setScreenValue.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -913,11 +914,14 @@
     *          The value to be set via SCREEN-VALUE attribute.
     * @param   inUIStmt
     *          Flag indicating this call originates from a UI statement.
+    * @param   unparsedValue
+    *          The value to be set via SCREEN-VALUE before suffering parse changes. This can be omitted
+    *          if it is not mandatory during validation.
     *          
     * @return  <code>true</code> if the caller can proceed, as the screen-value can be set.
     */
    @Override 
-   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt)
+   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt, character unparsedValue)
    {
       if (!(value instanceof character))
       {
@@ -932,7 +936,7 @@
          cvalue.setUnknown();
       }
 
-      return super.setScreenValue(frameBuf, cvalue, inUIStmt);
+      return super.setScreenValue(frameBuf, cvalue, inUIStmt, unparsedValue);
    }
    
    /**

=== modified file 'src/com/goldencode/p2j/ui/ToggleBoxWidget.java'
--- old/src/com/goldencode/p2j/ui/ToggleBoxWidget.java	2023-09-29 13:41:44 +0000
+++ new/src/com/goldencode/p2j/ui/ToggleBoxWidget.java	2024-02-01 14:36:23 +0000
@@ -2,7 +2,7 @@
 ** Module   : ToggleBoxWidget.java
 ** Abstract : Toggle-box widget.
 **
-** Copyright (c) 2010-2022, Golden Code Development Corporation.
+** Copyright (c) 2010-2024, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 SVL 20101004 Created initial version.
@@ -44,6 +44,7 @@
 **                  realized.
 ** 021 AL2 20230929 Removed previous fix regarding setChecked being ignored while not realized. The setter
 **                  updates the screen-value anyway. The ASSIGN however has a quirk that was misleading here.
+** 022 RAA 20240201 Added unparsedValue parameter to setScreenValue.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -179,18 +180,21 @@
     *          The value to be set via SCREEN-VALUE attribute.
     * @param   inUIStmt
     *          Flag indicating this call originates from a UI statement.
+    * @param   unparsedValue
+    *          The value to be set via SCREEN-VALUE before suffering parse changes. This can be omitted
+    *          if it is not mandatory during validation.
     *          
     * @return  <code>true</code> if the caller can proceed, as the screen-value can be set.
     */
    @Override
-   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt)
+   boolean setScreenValue(ScreenBuffer frameBuf, Object value, boolean inUIStmt, character unparsedValue)
    {
       if (value instanceof BaseDataType && ((BaseDataType) value).isUnknown())
       {
          ((BaseDataType) value).assign(new logical(false));
       }
       
-      return super.setScreenValue(frameBuf, value, inUIStmt);
+      return super.setScreenValue(frameBuf, value, inUIStmt, unparsedValue);
    }
    
    /**